// Persistence of Vision Raytracer 
// Version 0.4 beta
// BETA Version of Standard textures file
// This file will probably change again before we release Ver 1.0


// White marble with red veins	
#declare Red_Marble =
texture {
	pigment {
		marble
		turbulence 1.0
		color_map {
			[0.0 0.8   color rgb <0.8, 0.8, 0.6> color rgb <0.8, 0.4, 0.4>]
			[0.8 1.001 color rgb <0.8, 0.4, 0.4> color rgb <0.8, 0.2, 0.2>]
		}
	}
}

// White marble with black veins	
#declare White_Marble =
texture {
	pigment {
		marble
		turbulence 1.0
		color_map {
			[0.0 0.8  color rgb <0.9, 0.9, 0.9> color rgb <0.5, 0.5, 0.5>]
			[0.8 1.01 color rgb <0.5, 0.5, 0.5> color rgb <0.2, 0.2, 0.2>]
		}
	}
}

// Light blue and black marble with a thin red vein 
// Try changing LBlue and Vein below to modify the marble
#declare LBlue = color rgb <0.0, 0.6, 0.6>;
#declare Vein = color rgb <0.6, 0.0, 0.0>;
#declare Blood_Marble =
texture {
	pigment {
		marble
		turbulence 2.3
		color_map {
			[0.0 0.8   color Black color LBlue]
			[0.8 0.9   color LBlue color Vein]
			[0.9 1.001 color Vein color Black]
		}
	}
}

// a grey blue agate -- kind of purplish
#declare Blue_Agate =
texture {
	pigment {
		agate
		color_map {
			[0.0 0.5   color rgb <0.30, 0.30, 0.50> color rgb <0.30, 0.30, 0.50>]
			[0.5 0.55  color rgb <0.30, 0.30, 0.50> color rgb <0.20, 0.20, 0.30>]
			[0.55 0.6  color rgb <0.20, 0.20, 0.30> color rgb <0.25, 0.25, 0.35>]
			[0.6 0.7   color rgb <0.25, 0.25, 0.35> color rgb <0.15, 0.15, 0.26>]
			[0.7 0.8   color rgb <0.15, 0.15, 0.26> color rgb <0.10, 0.10, 0.20>]
			[0.8 0.9   color rgb <0.10, 0.10, 0.20> color rgb <0.30, 0.30, 0.50>]
			[0.9 1.001 color rgb <0.30, 0.30, 0.50> color rgb <0.10, 0.10, 0.20>]
		}
	}
}

// Deep blue agate -- almost glows
#declare Sapphire_Agate =
texture {
	pigment {
		agate
		color_map {
			[0.0 0.3   color rgb <0.0, 0.0, 0.9> color rgb <0.0, 0.0, 0.8>]
			[0.3 1.001 color rgb <0.0, 0.0, 0.8> color rgb <0.0, 0.0, 0.4>]
		}
	}
}

// Brown and white agate -- very pretty
#declare Brown_Agate =
texture {
	pigment {
		agate
		color_map {
			[0.0 0.5   color rgb <1.0, 1.0, 1.0> color rgb <0.9, 0.7, 0.6>]
			[0.5 0.6   color rgb <0.9, 0.7, 0.6> color rgb <0.9, 0.7, 0.4>]
			[0.6 1.001 color rgb <0.9, 0.7, 0.4> color rgb <0.7, 0.4, 0.2>]
		}
	}
}

// Desert landscape
#declare Desert =
texture {
	pigment {
		color rgb <1.0, 0.66, 0.2>
	}
	normal {
		ripples 0.5
		frequency 2000
		scale 50000
	}
	finish {
		crand 0.05
		ambient 0.3
		diffuse 0.7
	}
}

// Grass texture
#declare Grass =
texture {
	pigment {
		spotted
		color_map {
			//[0.0 0.9  color rgb <0.137255, 0.556863, 0.137255> color rgb <0.137255, 0.6, 0.14>]
			//[0.9 1.01 color rgb <0.309, 0.3098, 0.18> color rgb <0.309, 0.3098, 0.17>]
			
			//above colors are a bit too bright, tone them down
			[0.0 0.9  color DarkGreen color DarkOliveGreen]
			[0.9 1.01 color Khaki color DarkGreen]
		}
	}
	normal {
		ripples 0.5
		frequency 1500
		scale 50000
	}
	finish {
		crand 0.05
		ambient 0.3
		diffuse 0.7
	}
}

// Basic CBlue Sky w/ clouds
#declare Blue_Sky =
texture {
	pigment {
		bozo
		turbulence 0.3
		color_map {
			[0.0 0.5   color rgb <0.25, 0.25, 0.5> color rgb <0.25, 0.25, 0.5>]
			[0.5 0.6   color rgb <0.25, 0.25, 0.5> color rgb <0.7, 0.7, 0.7>]
			[0.6 1.001 color rgb <0.7, 0.7, 0.7>   color rgb <0.3, 0.3, 0.3>]
		}
	}
}

// Bright CBlue Sky w/ very white clouds
#declare Bright_Blue_Sky =
texture {
	pigment {
		bozo
		turbulence 0.56
		color_map {
			[0.0 0.5  color rgb <0.5, 0.5, 1.0> color rgb <0.5, 0.5, 1.0>]
			[0.5 0.6  color rgb <0.5, 0.5, 1.0> color rgb <1.0, 1.0, 1.0>]
			[0.6 1.01 color rgb <1.0, 1.0, 1.0> color rgb <0.5, 0.5, 0.5>]
		}
	}
}

// CRed sky w/ yellow clouds -- very surreal
#declare Blood_Sky =
texture {
	pigment {
		bozo
		turbulence 0.5
		color_map {
			[0.0 0.5  color rgb <0.9, 0.7, 0.0>	color rgb <0.3, 0.2, 0.0>]		
			[0.5 0.6  color rgb <0.6, 0.025, 0.0> color rgb <0.9, 0.7, 0.0>]
			[0.6 1.01 color rgb <0.6, 0.025, 0.0> color rgb <0.6, 0.025, 0.0>]
		}
	}
}

// Black sky with red and purple clouds 
// Try adding turbulence values from 0.1 - 5.0 -- CdW
#declare Apocalypse =
texture {
	pigment {
		bozo
		color_map {
			[0.0 0.4  color rgb <0.8, 0.0, 0.0> color rgb <0.4, 0.0, 0.4>]
			[0.4 0.6  color rgb <0.4, 0.0, 0.4> color rgb <0.0, 0.0, 0.2>]
			[0.6 1.01 color rgb <0.0, 0.0, 0.2> color rgb <0.0, 0.0, 0.0>]
		}
	}
}

// White clouds w/ transparent sky
#declare Clouds =
texture {
	pigment {
		bozo
		turbulence 0.0
		color_map {
			[0.0 0.1   color rgb <0.8, 0.8, 0.8> color rgb <0.8, 0.8, 0.8>]		
			[0.1 0.5   color rgbf <0.8, 0.8, 0.8, 0.0> color rgbf <1.0, 1.0, 1.0, 1.0>]
			[0.5 1.001 color rgbf <1.0, 1.0, 1.0, 1.0> color rgbf <1.0, 1.0, 1.0, 1.0>]
		}
	}
}

// Wood often looks better when scaled more in one direction
// ie. scale <10.0 5.0 5.0> Try different values.

// a light reddish wood
#declare Cherry_Wood =
texture {
	pigment {
		wood
		turbulence 0.3
		color_map {
			[0.0 0.8  color rgb <0.666, 0.312, 0.2> color rgb <0.666, 0.312, 0.2>]
			[0.8 1.01 color rgb <0.4, 0.133, 0.066> color rgb <0.2, 0.065, 0.033>]
		}
	}
}

// a light tan wood with greenish rings
#declare Pine_Wood =
texture {
	pigment {
		wood
		turbulence 0.2
		color_map {
			[0.0 0.8  color rgb <1.0, 0.71875, 0.25> color rgb <1.0, 0.71875, 0.25>]
			[0.8 1.01 color rgb <0.5, 0.5, 0.066> color rgb <0.4, 0.4, 0.033>]
		}
	}
}

// a dark wood with a greenish hue to it
#declare Dark_Wood =
texture {
	pigment {
		wood
		turbulence 0.2
		color_map {
			[0.0 0.8  color rgb <0.42857, 0.23810, 0.04762> color rgb <0.42857, 0.23810, 0.04762>]
			[0.8 1.01 color rgb <0.4, 0.333, 0.066> color rgb <0.2, 0.033, 0.033>]
		}
	}
}

// a light tan wood with brown rings
#declare Tan_Wood =
texture {
	pigment {
		wood
		turbulence 0.1
		color_map {
			[0.0 0.8  color rgb <0.888, 0.600, 0.3> color rgb <0.888, 0.600, 0.3>]
			[0.8 1.01 color rgb <0.6, 0.4, 0.2> color rgb <0.4, 0.3, 0.2>]
		}
	}
}

// a very pale wood with tan rings -- kind of balsa-ish
#declare White_Wood =
texture {
	pigment {
		wood
		turbulence 0.6
		color_map {
			[0.0 0.8  color rgb <0.93, 0.71, 0.532> color rgb <0.98, 0.81, 0.6>]
			[0.8 1.01 color rgb <0.6, 0.333, 0.266> color rgb <0.7, 0.6, 0.23>]
		}
	}
}

// Brown wood - looks stained 
// Nice color map by Tom Price
#declare Tom_Wood =
texture {
	pigment {
		wood
		turbulence 0.31
		color_map {
			[0.0 0.8   color rgb <0.7, 0.3, 0.0> color rgb <0.7, 0.3, 0.0>]
			[0.8 1.01  color rgb <0.5, 0.2, 0.0> color rgb <0.4, 0.1, 0.0>]
		}
	}
}

// Concrete Texture
#declare Concrete =
texture {
	pigment {
		spotted
		turbulence 0.1
		color_map {
			[0.0 0.9 color rgb <0.85, 0.85, 0.85> color rgb <0.9, 0.9, 0.9>]
			[0.9 1.01 color rgb <0.7, 0.7, 0.7> color rgb <0.8, 0.8, 0.75>]
		}
	}
}

// Dull creates a large, soft highlight on the object's surface
#declare Dull =
finish {
	specular 0.5
	roughness 0.15
}
// Shiny creates a small, tight highlight on the object's surface
#declare Shiny =
finish {
	specular 1.0
	roughness 0.006
}

// Phong highlights are less realistic than specular, but useful
// for different effects.
// Dull creates a large, soft highlight on the object's surface
#declare Phong_Dull =
finish {
	phong 0.5
	phong_size 1
}

// Shiny creates a small, tight highlight on the object's surface
#declare Phong_Shiny =
finish {
	phong 1.0
	phong_size 50
}

// a perfectly mirrored texture with no highlights
#declare Mirror =
finish {
	ambient 0.0
	diffuse 0.0
	reflection 1.0
}

// Luminous really doesn't look good
#declare Luminous =
finish {
	ambient 1.0
	diffuse 0.0
}

// Do we need transmit??
#declare Glass =
texture {
	finish { Shiny }
	pigment {
		color rgbf <1.0, 1.0, 1.0, 0.7>
	}
	finish {
		ambient 0.0
		diffuse 0.0
		reflection 0.1
		//refraction 1.0
		//ior 1.5	  
		//transmit 0.0
	}
}

#declare Glass2 =
texture {
	pigment {
		color rgbf <1.0, 1.0, 1.0, 1.0>
	}
	finish {
		ambient 0.0
		diffuse 0.0
		reflection 0.5
		//refraction 0.85
		//ior 1.5
		phong 0.3
		phong_size 60
		//transmit 0.0
	}
}

// You need to specify a color when Metal is used
#declare Metal =
finish {
	metallic
	ambient 0.2
	diffuse 0.7
	brilliance 6.0
	reflection 0.25
	phong 0.75
	phong_size 20
}

// Good looking "metal" textures 
// important:
// They require that colors.dat be included before textures.dat

#declare Chrome_Texture =
texture {
	finish {
		ambient 0.3
		diffuse 0.7
		reflection 0.15
		brilliance 8.0
		specular 0.8
		roughness 0.1
	}
	pigment { color LightGray }
}


#declare Brass_Texture =
texture {
	finish { Metal }
	pigment { color Brass }
}

#declare Gold_Texture =
texture {
	finish { Metal }
	pigment { color BrightGold }
}

#declare Bronze_Texture =
texture {
	finish { Metal }
	pigment { color Bronze }
}

#declare Copper_Texture =
texture {
	finish { Metal }
	pigment { color Copper }
}

#declare Silver_Texture =
texture {
	finish { Metal }
	pigment { color Silver }
}

// Interesting texture -- Give it a try.
#declare Brass_Valley =
texture {
	pigment {
		granite
		color_map {
			[0.0 0.3   color Feldspar  color Feldspar]
			[0.3 0.6   color Mica      color Quartz]
			[0.6 1.001 color Feldspar  color Quartz]
		}
	}
	finish {
		metallic
		brilliance 6.0
		reflection 0.75
		phong 0.75
	}
}

#declare Rusty_Iron =
texture {
	pigment {
		agate
		color_map {
			[0.0 0.5   color rgb <0.21, 0.1, 0.1> color rgb <0.25, 0.25, 0.01>]
			[0.5 0.6   color rgb <0.25, 0.25, 0.01> color rgb <0.3, 0.1, 0.1>]
			[0.6 1.001 color rgb <0.15, 0.1, 0.1> color rgb <0.15, 0.1, 0.1>]
		}
	}
}

#declare Rust =
texture {
	pigment {
		spotted
		color_map {
			[0.0 0.4   color rgb <0.89, 0.51, 0.28> color rgb <0.70, 0.13, 0.00>]
			[0.4 0.5   color rgb <0.70, 0.13, 0.00> color rgb <0.69, 0.41, 0.08>]
			[0.5 0.6   color rgb <0.69, 0.41, 0.08> color rgb <0.49, 0.31, 0.28>]
			[0.6 1.001 color rgb <0.49, 0.31, 0.28> color rgb <0.89, 0.51, 0.28>]
		}
	}
}

// CRed & white stripes - Looks best on a y axis Cylinder
#declare Candy_Cane = 
texture {
	// It "spirals" because it's gradient on two axis
	pigment {
		gradient <1, 1, 0> 
		color_map {
			[0.00 0.25  color rgb <1.0, 0.0, 0.0> color rgb <1.0, 0.0, 0.0>]
			[0.25 0.75  color rgb <1.0, 1.0, 1.0> color rgb <1.0, 1.0, 1.0>]
			[0.75 1.001 color rgb <1.0, 0.0, 0.0> color rgb <1.0, 0.0, 0.0>]
		}
	}
}

#declare Y_Gradient =
texture {
	pigment {
		gradient y
		color_map {
			[0.00 0.33  color rgb <1.0, 0.0, 0.0> color rgb <0.0, 0.0, 1.0>]
			[0.33 0.66  color rgb <0.0, 0.0, 1.0> color rgb <0.0, 1.0, 0.0>]
			[0.66 1.001 color rgb <0.0, 1.0, 0.0> color rgb <1.0, 0.0, 0.0>]
		}
	}
}

#declare X_Gradient =
texture {
	pigment {
		gradient x
		color_map {
			[0.00 0.33  color rgb <1.0, 0.0, 0.0> color rgb <0.0, 0.0, 1.0>]
			[0.33 0.66  color rgb <0.0, 0.0, 1.0> color rgb <1.0, 1.0, 1.0>]
			[0.66 1.001 color rgb <1.0, 1.0, 1.0> color rgb <1.0, 1.0, 1.0>]
		}
	}
}

// a good watery example
#declare Water =
texture {
	pigment {
		color Blue filter 0.9
	}
	normal {
		ripples 0.75
		frequency 10.0
	}
	finish {
		reflection 0.3
	}
	//refraction 0.5
	//ior 1.33
	//transmit 0.0
}

// No iridescence, but you might find a use for it.
#declare Pearl =
texture {		// You need to supply a color with alpha...
	finish {
		ambient 0.4
		diffuse 0.6
		brilliance 8.0
		reflection 0.75
		phong 1.0
		phong_size 30.0
	}
	//refraction 0.25
	//ior 2.5
	//transmit 0.0
}

#declare Jade =
texture {
	pigment {
		marble
		turbulence 1.8
		color_map {
			[0.0 0.8   color rgb <0.1, 0.6, 0.1> color rgb <0.0, 0.3, 0.0>]
			[0.8 1.001 color rgb <0.1, 0.6, 0.1> color rgb <0.0, 0.2, 0.0>]
		}
	}
}

