///****************************************************************************
//							 STONE TEXTURES
///****************************************************************************

// Gray-pink alabaster or marble.  Layers are scaled for a unit object
// and relative to each other.
#declare PinkAlabaster =
// Underlying surface is very subtly mottled with bozo
texture {
	pigment {
		bozo
		turbulence 0.25
		color_map {
			[0,  1 color red 0.9 green 0.75 blue 0.75 color red 0.6 green 0.6  blue 0.6 ]
		}
		scale 0.4
	}
	finish { ambient 0.25 }
}
// Second layer texture has some  filter values, yet a fair amount of color
// Viening is kept quite thin in color map and by the largish scale.
texture {
	pigment {
		granite
		color_map {
			[0,	0.9 color DustyRose  filter 1 color DustyRose  filter 0.5]
			[0.9, 1	color DarkSlateGray	  color DarkSlateGray]
		}
		scale 2		 // Twice as large as unit shape
	}
	// I know this seem contradictory, but it seems to work!
	finish {
		specular 1
		roughness 0.0001
		phong 0.25
		phong_size 75
		brilliance 4
	}
}

///****************************************************************************
//									SKY PIGMENTS
///****************************************************************************

// Basic Blue Sky w/ clouds.
#declare Blue_Sky = 
pigment {
	bozo
	turbulence 0.3
	color_map {
		[0.0, 0.5	color red 0.25 green 0.25 blue 0.5 color red 0.25 green 0.25 blue 0.5]
		[0.5, 0.6	color red 0.25 green 0.25 blue 0.5 color red 0.7  green 0.7  blue 0.7]
		[0.6, 1.001 color red 0.7  green 0.7  blue 0.7 color red 0.3  green 0.3  blue 0.3]
	}
}

// Bright Blue Sky w/ very white clouds.
#declare Bright_Blue_Sky = 
pigment {
	bozo
	turbulence 0.56
	color_map {
		[0.0, 0.5  color red 0.5 green 0.5 blue 1.0 color red 0.5 green 0.5 blue 1.0]
		[0.5, 0.6  color red 0.5 green 0.5 blue 1.0 color red 1.0 green 1.0 blue 1.0]
		[0.6, 1.01 color red 1.0 green 1.0 blue 1.0 color red 0.5 green 0.5 blue 0.5]
	}
}

// Another sky
#declare Blue_Sky2 = 
pigment{
	agate
	color_map {
		[ 0, 0.3  color Blue color Blue  ]
		[0.3,  1  color Blue	color White	]
	}
	scale 0.75
}

// Small puffs of white clouds
#declare Blue_Sky3 = 
pigment {
	granite
	turbulence 0.1
	color_map {
		[ 0, 0.3  color Blue color Blue  ]
		[0.3,  1  color Blue	color White	]
	}
	scale 0.75
}

// Red sky w/ yellow clouds -- very surreal.
#declare Blood_Sky = 
pigment {
	bozo
	turbulence 0.5
	color_map {
		[0.0, 0.5  color red 0.9 green 0.7 color red 0.3 green 0.2]
		[0.5, 0.6  color red 0.6 green 0.025 color red 0.9 green 0.7]
		[0.6, 1.01 color red 0.6 green 0.025 color red 0.6 green 0.025]
	}
}

// Black sky with red and purple clouds 
// Try adding turbulence values from 0.1 - 5.0 -- CdW
#declare Apocalypse = 
pigment {
	bozo
	color_map {
 		[0.0, 0.4  color red 0.8 color red 0.4 blue 0.4]
		[0.4, 0.6  color red 0.4 blue 0.4 color			blue 0.2]
		[0.6, 1.01 color			blue 0.2 color Black]
	}
}

// White clouds w/ transparent sky.
#declare Clouds = 
pigment {
	bozo
	turbulence 0
	color_map {
		[0.0, 0.1	color red 0.8 green 0.8 blue 0.8 color red 0.8 green 0.8 blue 0.8]
		[0.1, 0.5	color red 0.8 green 0.8 blue 0.8 color Clear]
		[0.5, 1.001 color Clear color Clear]
	}
}

///****************************************************************************
//									WOODEN PIGMENTS
///****************************************************************************

// Several wooden pigments by Tom Price:
// A light reddish wood.
#declare Cherry_Wood = 
pigment {
	wood
	turbulence 0.3
	color_map {
		[0.0, 0.8  color red 0.666 green 0.312 blue 0.2 color red 0.666 green 0.312 blue 0.2]
		[0.8, 1.01 color red 0.4 green 0.133 blue 0.066 color red 0.2 green 0.065 blue 0.033]
	}
}

// A light tan wood with greenish rings.
#declare Pine_Wood = 
pigment {
	wood
	turbulence 0.2
	color_map {
		[0.0, 0.8  color red 1.0 green 0.71875 blue 0.25 color red 1.0 green 0.71875 blue 0.25]
		[0.8, 1.01 color red 0.5 green 0.5	  blue 0.066 color red 0.4 green 0.4	  blue 0.033]
	}
}

// Dark wood with a greenish hue to it.
#declare Dark_Wood = 
pigment {
	wood
	turbulence 0.2
	color_map {
		[0.0, 0.8  color red 0.42857 green 0.23810 blue 0.04762 color red 0.42857 green 0.23810 blue 0.04762]
		[0.8, 1.01 color red 0.4	  green 0.333	blue 0.066 color red 0.2	  green 0.033	blue 0.033]
	}
}

// Light tan wood with brown rings.
#declare Tan_Wood = 
pigment {
	wood
	turbulence 0.1
	color_map {
		[0.0, 0.8  color red 0.888 green 0.600 blue 0.3 color red 0.888 green 0.600 blue 0.3]
		[0.8, 1.01 color red 0.6	green 0.4	blue 0.2 color red 0.4	green 0.3	blue 0.2]
	}
}

// A very pale wood with tan rings -- kind of balsa-ish.
#declare White_Wood = 
pigment {
	wood
	turbulence 0.6
	color_map {
		[0.0, 0.8  color red 0.93 green 0.71 blue 0.532 color red 0.98 green 0.81 blue 0.6]
		[0.8, 1.01 color red 0.6 green 0.333 blue 0.266 color red 0.7 green 0.6 blue 0.23]
	}
}

// Brown wood - looks stained.
#declare Tom_Wood = 
pigment {
	wood
	turbulence 0.31
	color_map {
		[0.0, 0.8	color red 0.7 green 0.3 color red 0.7 green 0.3]
		[0.8, 1.01  color red 0.5 green 0.2 color red 0.4 green 0.1]
	}
}

// The scaling in these definitions is relative to a unit-sized object
// (radius 1).  Note that woods are functionally equivilent to a log lying
// along the z axis.  For best results, think like a woodcutter trying to
// extract the nicest board out of that log.  A little tilt along the x axis
// will give elliptical rings of grain like you'd expect to find on most
// boards.  Experiment.
// (The first five came from DODEC2.POV in the POV Scenefile Library.)
#declare DMFWood1 = 
pigment {
	wood
	turbulence 0.04
	octaves 3
	scale <0.05, .05, 1>
	color_map {
		[0.00, 0.10 color red 0.60 green 0.30 blue 0.18 color red 0.60 green 0.30 blue 0.18]
		[0.10, 0.90 color red 0.60 green 0.30 blue 0.18 color red 0.30 green 0.15 blue 0.09]
		[0.90, 1.0  color red 0.30 green 0.15 blue 0.09 color red 0.30 green 0.15 blue 0.09]
	}
}

#declare DMFWood2 = 
pigment {
	wood
	turbulence 0.03
	octaves 4
	scale <0.05, .05, 1>
	color_map {
		[0.00, 0.10 color red 0.52 green 0.37 blue 0.26 color red 0.52 green 0.37 blue 0.26]
		[0.10, 0.90 color red 0.52 green 0.37 blue 0.26 color red 0.42 green 0.26 blue 0.15]
		[0.90, 1.0  color red 0.42 green 0.26 blue 0.15 color red 0.42 green 0.26 blue 0.15]
	}
}

#declare DMFWood3 = 
pigment {
	wood
	turbulence 0.05
	octaves 2
	scale <0.05, .05, 1>
	color_map {
		[0.00, 0.10 color red 0.4 green 0.133 blue 0.066 color red 0.4 green 0.133 blue 0.066]
		[0.10, 0.90 color red 0.4 green 0.133 blue 0.066 color red 0.2 green 0.065 blue 0.033]
		[0.90, 1.0  color red 0.2 green 0.065 blue 0.033 color red 0.2 green 0.065 blue 0.033]
	}
}

#declare DMFWood4 = 
pigment {
	wood
	turbulence 0.04
	octaves 3
	scale <0.05, .05, 1>
	color_map {
		[0.00, 0.10 color red 0.888 green 0.600 blue 0.3 color red 0.888 green 0.600 blue 0.3]
		[0.10, 0.90 color red 0.888 green 0.600 blue 0.3 color red 0.6 green 0.4 blue 0.2]
		[0.90, 1.0  color red 0.6 green 0.4 blue 0.2 color red 0.6 green 0.4 blue 0.2]
	}
}

#declare DMFWood5 = 
pigment {
	wood
	turbulence 0.05
	octaves 6
	scale <0.075, .075, 1>
	color_map {
		[0.00, 0.10 color red 0.3 green 0.1 blue 0.05 color red 0.3 green 0.1 blue 0.05]
		[0.10, 0.90 color red 0.3 green 0.1 blue 0.05 color red 0.25 green 0.07 blue 0.038]
		[0.90, 1.0  color red 0.25 green 0.07 blue 0.038 color red 0.25 green 0.07 blue 0.038]
	}
}

// Is this really oak?  I dunno.  Quite light, maybe more like spruce.
#declare DMFLightOak =  
pigment {
	wood
	turbulence 0.05				// For best results,  keep this low!
	scale <0.2, 0.2, 1>		  // Scaled for a unit object
	color_map {
		[0.00, 0.10 color red 0.42 green 0.26 blue 0.15 color red 0.42 green 0.26 blue 0.15]
		[0.10, 0.90 color red 0.42 green 0.26 blue 0.15 color red 0.52 green 0.37 blue 0.26]
		[0.90, 1.01 color red 0.52 green 0.37 blue 0.26 color red 0.52 green 0.37 blue 0.26]
	}
}

// Looks like old desk oak if used correctly.
#declare DMFDarkOak = 
pigment {
	wood
	turbulence 0.04				// For best results,  keep this low!
	octaves 3
	scale <0.2, 0.2, 1>		  // Scaled for a unit object
	color_map {
		[0.00, 0.10 color red 0.60 green 0.30 blue 0.18 color red 0.60 green 0.30 blue 0.18]
		[0.10, 0.90 color red 0.60 green 0.30 blue 0.18 color red 0.30 green 0.15 blue 0.09]
		[0.90, 1.01 color red 0.30 green 0.15 blue 0.09 color red 0.30 green 0.15 blue 0.09]
	}
}

// Wood by Eric Barish
#declare EMBWood1 = // Bottom wood-grain layer
texture {
	pigment {
		wood
		turbulence 0.05
		color_map {
			[0.00 0.34  color red 0.58 green 0.45 blue 0.23 color red 0.65 green 0.45 blue 0.25]
			[0.34 0.40  color red 0.65 green 0.45 blue 0.25 color red 0.33 green 0.23 blue 0.13]
			[0.40 0.47  color red 0.33 green 0.23 blue 0.13 color red 0.60 green 0.40 blue 0.20]
			[0.47 1.00  color red 0.60 green 0.40 blue 0.20 color red 0.25 green 0.15 blue 0.05]
		}
	}
	finish {
		crand 0.02
		ambient 0.32
		diffuse 0.63
		phong 0.2
		phong_size 10
	}
	normal { bumps 0.05 }
}
texture {	  // top layer, adds small dark spots 
	pigment {
		bozo
		color_map {
			[0.00 0.80  color red 1.00 green 1.00 blue 1.00  filter 1.00 color red 1.00 green 0.90 blue 0.80  filter 0.80]
			[0.80 1.00  color red 1.00 green 0.90 blue 0.80  filter 0.80 color red 0.30 green 0.20 blue 0.10  filter 0.40]
		}
		scale 0.25
	}
}


//	Doug Otwell woods
//	Yellow pine, close grained
//
#declare Yellow_Pine =
texture {
	pigment {
		wood
		turbulence 0.02
		color_map {
			[0.000, 0.222  color red 0.808 green 0.671 blue 0.251 filter 0.000 color red 0.808 green 0.671 blue 0.251 filter 0.000]
			[0.222, 0.342  color red 0.808 green 0.671 blue 0.251 filter 0.000 color red 0.600 green 0.349 blue 0.043 filter 0.000]
			[0.342, 0.393  color red 0.600 green 0.349 blue 0.043 filter 0.000 color red 0.808 green 0.671 blue 0.251 filter 0.000]
			[0.393, 0.709  color red 0.808 green 0.671 blue 0.251 filter 0.000 color red 0.808 green 0.671 blue 0.251 filter 0.000]
			[0.709, 0.821  color red 0.808 green 0.671 blue 0.251 filter 0.000 color red 0.533 green 0.298 blue 0.027 filter 0.000]
			[0.821, 1		color red 0.533 green 0.298 blue 0.027 filter 0.000 color red 0.808 green 0.671 blue 0.251 filter 0.000]
		}
		scale 0.1
		translate <10, 0, 0>
	}
}
// Yellow_Pine layer 2
texture {
	pigment {
		wood
		turbulence 0.01
		color_map {
			[0.000, 0.120 color red 1.000 green 1.000 blue 1.000 filter 1.000 color red 0.702 green 0.412 blue 0.118 filter 0.608]
			[0.120, 0.231 color red 0.702 green 0.412 blue 0.118 filter 0.608 color red 0.702 green 0.467 blue 0.118 filter 0.608]
			[0.231, 0.496 color red 0.702 green 0.467 blue 0.118 filter 0.608 color red 1.000 green 1.000 blue 1.000 filter 1.000]
			[0.496, 0.701 color red 1.000 green 1.000 blue 1.000 filter 1.000 color red 1.000 green 1.000 blue 1.000 filter 1.000]
			[0.701, 0.829 color red 1.000 green 1.000 blue 1.000 filter 1.000 color red 0.702 green 0.467 blue 0.118 filter 0.608]
			[0.829, 1	  color red 0.702 green 0.467 blue 0.118 filter 0.608 color red 1.000 green 1.000 blue 1.000 filter 1.000]
		}
		scale 0.5 
		translate <10, 0, 0>
	}
}

//
//	Rosewood
//
#declare Rosewood =
texture {
	pigment {
		bozo
		turbulence 0.04
		color_map {
			[0.000, 0.256	color red 0.204 green 0.110 blue 0.078 filter 0.000 color red 0.231 green 0.125 blue 0.090 filter 0.000]
			[0.256, 0.393	color red 0.231 green 0.125 blue 0.090 filter 0.000 color red 0.247 green 0.133 blue 0.090 filter 0.000]
			[0.393, 0.581	color red 0.247 green 0.133 blue 0.090 filter 0.000 color red 0.204 green 0.110 blue 0.075 filter 0.000]
			[0.581, 0.726	color red 0.204 green 0.110 blue 0.075 filter 0.000 color red 0.259 green 0.122 blue 0.102 filter 0.000]
			[0.726, 0.983	color red 0.259 green 0.122 blue 0.102 filter 0.000 color red 0.231 green 0.125 blue 0.086 filter 0.000]
			[0.983, 1		 color red 0.231 green 0.125 blue 0.086 filter 0.000 color red 0.204 green 0.110 blue 0.078 filter 0.000]
		}
		scale <0.5, 0.5, 1>
		translate <10, 0, 0>
	}
	finish {
		ambient 0.5
		diffuse 0.8
	}
}
// Rosewood layer 2
texture {
	pigment {
		wood
		turbulence 0.04
		color_map {
			[0.000, 0.139	color red 0.545 green 0.349 blue 0.247 filter 1.000 color red 0.000 green 0.000 blue 0.000 filter 0.004]
			[0.139, 0.148	color red 0.000 green 0.000 blue 0.000 filter 0.004 color red 0.000 green 0.000 blue 0.000 filter 0.004]
			[0.148, 0.287	color red 0.000 green 0.000 blue 0.000 filter 0.004 color red 0.545 green 0.349 blue 0.247 filter 1.000]
			[0.287, 0.443	color red 0.545 green 0.349 blue 0.247 filter 1.000 color red 0.545 green 0.349 blue 0.247 filter 1.000]
			[0.443, 0.626	color red 0.545 green 0.349 blue 0.247 filter 1.000 color red 0.000 green 0.000 blue 0.000 filter 0.004]
			[0.626, 0.635	color red 0.000 green 0.000 blue 0.000 filter 0.004 color red 0.000 green 0.000 blue 0.000 filter 0.004]
			[0.635, 0.843	color red 0.000 green 0.000 blue 0.000 filter 0.004 color red 0.545 green 0.349 blue 0.247 filter 1.000]
			[0.843, 1		 color red 0.545 green 0.349 blue 0.247 filter 1.000 color red 0.545 green 0.349 blue 0.247 filter 1.000]
		}
		scale <0.5, 0.5, 1>
		translate <10, 0, 0>
	}
	finish {
		ambient 0.5
		diffuse 0.8
	}
}

//
//	Sandalwood ( makes a great burled maple, too)
//
#declare Sandalwood =
texture {
	pigment {
		bozo
		turbulence 0.2
		color_map {
			[0.000, 0.171	color red 0.725 green 0.659 blue 0.455 filter 0.000 color red 0.682 green 0.549 blue 0.420 filter 0.000]
			[0.171, 0.274	color red 0.682 green 0.549 blue 0.420 filter 0.000 color red 0.557 green 0.451 blue 0.322 filter 0.000]
			[0.274, 0.393	color red 0.557 green 0.451 blue 0.322 filter 0.000 color red 0.725 green 0.659 blue 0.455 filter 0.000]
			[0.393, 0.564	color red 0.725 green 0.659 blue 0.455 filter 0.000 color red 0.682 green 0.549 blue 0.420 filter 0.000]
			[0.564, 0.701	color red 0.682 green 0.549 blue 0.420 filter 0.000 color red 0.482 green 0.392 blue 0.278 filter 0.000]
			[0.701, 1		 color red 0.482 green 0.392 blue 0.278 filter 0.000 color red 0.725 green 0.659 blue 0.455 filter 0.000]
		}
		scale <0.2, 0.2, 1>
		scale 2
	}
}
// Sandalwood layer 2
texture {
	pigment {
		bozo
		turbulence 0.8
		color_map {
			[0.000, 0.087	color red 0.682 green 0.604 blue 0.380 filter 1.000 color red 0.761 green 0.694 blue 0.600 filter 0.020]
			[0.087, 0.226	color red 0.761 green 0.694 blue 0.600 filter 0.020 color red 0.635 green 0.553 blue 0.325 filter 1.000]
			[0.226, 0.348	color red 0.635 green 0.553 blue 0.325 filter 1.000 color red 0.761 green 0.694 blue 0.600 filter 0.020]
			[0.348, 0.496	color red 0.761 green 0.694 blue 0.600 filter 0.020 color red 0.682 green 0.604 blue 0.380 filter 1.000]
			[0.496, 0.565	color red 0.682 green 0.604 blue 0.380 filter 1.000 color red 0.761 green 0.694 blue 0.600 filter 0.020]
			[0.565, 0.661	color red 0.761 green 0.694 blue 0.600 filter 0.020 color red 0.682 green 0.604 blue 0.380 filter 1.000]
			[0.661, 0.835	color red 0.682 green 0.604 blue 0.380 filter 1.000 color red 0.761 green 0.694 blue 0.600 filter 0.020]
			[0.835, 1		 color red 0.761 green 0.694 blue 0.600 filter 0.020 color red 0.682 green 0.604 blue 0.380 filter 1.000]
		}
		scale 0.2
		scale 2
	}
}
